on startMovie
  global NumMaps, NumIsotherms, NumSpaces, MapAnalysing, rate, TimeCheck, Difficulty
  set TimeCheck to 0
  GameStart(MapAnalysing)
  if MapAnalysing = 0 then
    set MapAnalysing to 0.10000000000000001
  end if
  set rate to 2
  set NumMaps to 2
  set NumIsotherms to 2
  set NumSpaces to 10
  set the checkBoxAccess to 1
end

on StartGame
  global NumMaps, NoQuiz, NumberOfQuestions, QuestionNum, MapNum, Temp1, Temp2, Score1, Score2, TimeCheck, rate
  set the soundEnabled to 1
  set Temp1 to 0
  set Temp2 to 0
  set Score1 to 0
  set Score2 to 0
  BStart(30, 34)
  go("Game1")
  set the movieTime of sprite 4 to 0
  set the movieRate of sprite 4 to rate
  set TimeCheck to 1
  set NumberOfQuestions to 8
  set the puppet of sprite 9 to 1
  set the puppet of sprite 10 to 1
  set MapNum to random(NumMaps)
  set the castNum of sprite 9 to 100 + MapNum
  set NoQuiz to 1
  set QuestionNum to 0
  OrderQuestions()
  ShowIsotherm()
end

on stop
  global TimeCheck, NoQuiz, QuizWaiting
  cursor(4)
  set TimeCheck to 0
  BSuspend(9, 10)
  BSuspend(12, 21)
  BStop()
  go(2)
  set the mouseDownScript to EMPTY
  set the mouseUpScript to EMPTY
  set the keyDownScript to EMPTY
  set NoQuiz to 0
  if QuizWaiting = 1 then
    PopQuiz()
  end if
  cursor(-1)
end

on EndGame
  global Score1, Score2, BoxUp, rate, TimeCheck
  set TimeCheck to 0
  set the movieRate of sprite 4 to 0
  put "Done!  You took " & WriteTime(4, rate) & ".  Your score is " & score() & "." into field "MsgBox"
  set BoxUp to 1
  go("BoxUp")
end

on TimeUp
  global Score1, Score2, TimeCheck, TimeSec, BoxUp
  set TimeCheck to 0
  set the movieRate of sprite 4 to 0
  set TimeSec to 360
  puppetSound("Game Over")
  put "Time Up!  Your score is " & score() & "." into field "MsgBox"
  set BoxUp to 1
  go("BoxUp")
end

on score
  global Score1, Score2, Difficulty, MapAnalysing, rate
  set GameScore to (Score1 * 1000) + (Score2 * 500) - (time(4, rate) * 15)
  if GameScore < 0 then
    set GameScore to 0
  end if
  if GameScore > MapAnalysing then
    set MapAnalysing to GameScore
  end if
  ScoreDisplay()
  return GameScore
end

on ShowBox
  global BoxUp
  set BoxUp to 0
  BSuspend(29, 29)
  stop()
end

on BoxUp
  if (the clickOn >= 27) and (the clickOn <= 29) then
    pass()
  else
    if the mouseDown = 1 then
      beep()
    end if
    dontPassEvent()
  end if
end

on KeyCheck
  if the key = RETURN then
    ShowBox()
  else
    pass()
  end if
end

on ScientistScreen
  cursor(4)
  go(1, the pathName & "DALEY_S.DIR")
  cursor(4)
end

on idle
  global TimeCheck
  if (TimeCheck <> 0) and (the frame > 2) then
    if the movieRate of sprite 4 = 0 then
      TimeUp()
    end if
  end if
  GameIdle()
  PopIdle()
end

on Compute1 YesNoA
  global YesNoAnswer, IsothermAnswer, Isotherm, YesNo, QuestionNum, NumberOfQuestions, Score1, Score2, Difficulty
  set YesNoAnswer to YesNoA
  if YesNoAnswer = YesNo then
    puppetSound("1Right")
    set Score2 to Score2 + 1
  else
    puppetSound("0Right")
  end if
  if (Difficulty = 0) or (YesNo = 0) or (YesNoAnswer <> YesNo) then
    if QuestionNum >= NumberOfQuestions then
      EndGame()
      exit
    end if
    ShowIsotherm()
  else
    BSuspend(20, 21)
    go("Game2")
  end if
end

on Compute2 IsothermA
  global YesNoAnswer, IsothermAnswer, Isotherm, YesNo, QuestionNum, NumberOfQuestions, Score1, Score2, Difficulty
  set IsothermAnswer to IsothermA
  if IsothermAnswer = Isotherm then
    puppetSound("2Right")
    set Score1 to Score1 + 1
  else
    puppetSound("0Right")
  end if
  if QuestionNum >= NumberOfQuestions then
    EndGame()
    exit
  end if
  BSuspend(12, 19)
  ShowIsotherm()
end

on ShowIsotherm
  global NumIsotherms, NumMaps, NumSpaces, MapNum, IsothermCast, YesNo, Isotherm, QuestionNum, Order
  set QuestionNum to QuestionNum + 1
  set Isotherm to value(line QuestionNum of Order)
  set Temp to random(NumIsotherms)
  if Temp = 1 then
    set YesNo to 1
  else
    set YesNo to 0
  end if
  set Temp to Temp - 1 + ((2 * MapNum) - 1)
  set IsothermCast to Temp - 1 + (Isotherm * NumSpaces) - (NumSpaces - 1) + 110
  set the castNum of sprite 10 to IsothermCast
  go("Game1")
  if YesNo = 0 then
    set Isotherm to 0
  end if
end

on OrderQuestions
  global NumberOfQuestions, Order
  repeat with count = 1 to NumberOfQuestions
    put 0 into line count of Order
  end repeat
  repeat with count = 1 to NumberOfQuestions
    set Temp to random(NumberOfQuestions)
    repeat while line Temp of Order <> 0
      set Temp to random(NumberOfQuestions)
    end repeat
    put count into line Temp of Order
  end repeat
end

on ShowInfoPrep
  global TimeCheck, TempTimeCheck
  if the frame > 2 then
    set TempTimeCheck to TimeCheck
    set TimeCheck to 0
    set the movieRate of sprite 4 to 0
  end if
  return 1
end

on HideInfoComplete
  global TimeCheck, TempTimeCheck, rate
  if (the frame > 2) and (the frame < 9) then
    set the movieRate of sprite 4 to rate
    set TimeCheck to TempTimeCheck
  end if
end
